require('lquery')
require('ui')
require('ui.button')
require('ui.list')
require('ui.menu')
console = G.newFont('data/fonts/ru.ttf', 13)

background = Entity:new(screen)
:image(G.newImage('data/gfx/bg.jpg'))
local scale = G.getHeight()/background.h
background
:scale(scale,scale)
:move(G.getWidth()/2 - background.w*scale/2, G.getHeight()/2 - background.h*scale/2)

local options = {}
options['menu_effect'] = 1

local menu_effects = {
  --switch without effect
  function (m1, m2) --switch from m1 to m2 with effects
    m1:hide()
    m2:show()
  end,
  
  --fade
  function (m1, m2) --switch from m1 to m2 with effects
    for k, v in pairs(m1._child) do
      v :stop('menu_toggle')
        :animate({a=0}, {queue='menu_toggle',speed=0.6})
    end
    m1:stop('menu_toggle')
      :delay({
        speed=0.6,
        queue = 'menu_toggle', 
        cb = function(s)
          m1:hide()
          for k, v in pairs(m1._child) do
            v:set({a=230})
          end
        end
      })
    for k, v in pairs(m2._child) do
      v:set({a=0}):stop('menu_toggle'):animate({a=230}, {queue='menu_toggle',speed=0.6})
    end
    m2:show()
  end,
  
  --fade one by one with delay
  function (m1, m2) --switch from m1 to m2 with effects
    for k, v in pairs(m1._child) do
      v :stop('menu_toggle')
        :delay({
          speed = k/20, 
          queue = 'menu_toggle', 
          cb = function(s)
            s:animate({a=0}, {queue='menu_toggle'})
          end
        })
    end
    m1:stop('menu_toggle')
      :delay({
        speed = (#m1._child+1)/20+0.3, 
        queue = 'menu_toggle', 
        cb = function(s)
          m1:hide()
          for k, v in pairs(m1._child) do
            v:set({a=230})
          end
          for k, v in pairs(m2._child) do
            v:set({a=0}):stop('menu_toggle'):delay({speed=k/20, queue='menu_toggle', cb=function(s)s:animate({a=230}, {queue='menu_toggle'})end})
          end
          m2:show()
        end
      })
  end,
  
  --slide one by one with delay
  function (m1, m2) --switch from m1 to m2 with effects
    for k, v in pairs(m1._child) do
      v :stop('menu_toggle')
        :delay({
          speed = k/20, 
          queue = 'menu_toggle', 
          cb = function(s)
            s:animate({x=-256}, {queue='menu_toggle'})
          end
        })
    end
    m1:stop('menu_toggle')
      :delay({
        speed = (#m1._child+1)/20+0.3, 
        queue = 'menu_toggle', 
        cb = function(s)
          for k, v in pairs(m1._child) do
            v:set({x=400-128})
          end
          m1:hide()
          for k, v in pairs(m2._child) do
            v:set({x=-256}):stop('menu_toggle'):delay({speed=k/20, queue='menu_toggle', cb=function(s)s:animate({x=400-128}, {queue='menu_toggle'})end})
          end
          m2:show()
        end
      })
  end
}
local function menu_toggle(m1, m2)
  menu_effects[options['menu_effect']](m1, m2)
end

--[[
menu_main = Entity:new(screen)
Entity:new(menu_main):button('New game'):move(400-128,70)
Entity:new(menu_main):button('Resume game'):move(400-128,140)
Entity:new(menu_main):button('Settings', 
function(self, x, y, b)
  menu_toggle(menu_main, menu_options)
end):move(400-128,210)
Entity:new(menu_main):button('Quit', 
function()
  love.event.push('q')
end)
:move(400-128,300)

menu_options = Entity:new(screen):hide()
Entity:new(menu_options):button('Graphics', 
function()
menu_toggle(menu_options, menu_graphics)
end):move(400-128,70)
Entity:new(menu_options):button('Audio'):move(400-128,140)
Entity:new(menu_options):button('Game'):move(400-128,210)
Entity:new(menu_options):button('Back', 
function()
menu_toggle(menu_options, menu_main)
end)
:move(400-128,300)

menu_graphics = Entity:new(screen):hide()
Entity:new(menu_graphics):button('1'):move(400-128,70)
Entity:new(menu_graphics):button('2'):move(400-128,140)
Entity:new(menu_graphics):button('3'):move(400-128,210)
Entity:new(menu_graphics):button('Back', 
function()
menu_toggle(menu_graphics, menu_options)
end):move(400-128,300)
]]

menu_main = Entity:new(screen):menu({
{text = 'New game', action = function() menu_toggle(menu_main, menu_game) end},
{text = 'Load'},
{text = 'Settings', action = function() menu_toggle(menu_main, menu_settings) end},
{text = 'Quit', action = function() love.event.push('q') end, offset = 10}
})
menu_settings = Entity:new(screen):menu({
{text = 'Graphics', action = function() menu_toggle(menu_settings, menu_graphics) end},
{text = 'Audio', action = function() menu_toggle(menu_settings, menu_audio) end},
{text = 'Game'},
{text = 'Back', action = function() menu_toggle(menu_settings, menu_main) end, offset = 10},
}):hide()
menu_graphics = Entity:new(screen):menu({
{text = '1'},
{text = '2'},
{text = '3'},
{text = 'Back', action = function() menu_toggle(menu_graphics, menu_settings) end, offset = 10},
}):hide()
menu_audio = Entity:new(screen):menu({
{text = '4'},
{text = '5'},
{text = '6'},
{text = 'Back', action = function() menu_toggle(menu_audio, menu_settings) end, offset = 10},
}):hide()
menu_game = Entity:new(screen):menu({
{text = 'Coming soon'},
{text = 'Back', action = function() menu_toggle(menu_game, menu_main) end, offset = 10},
}):hide()

Entity:new(screen):list('Menu change effect:', {'none', 'fade', 'fade 2', 'slide'}, options, 'menu_effect'):move(200, 500)

text = Entity:new(screen):draw(function(s)
  G.setColor(255,255,255,255)
  G.setFont(console)
  G.print('fps: '..love.timer.getFPS() .. '\nMemory: ' .. gcinfo(),s.x,s.y)
end)

require('lquery')
